#include "rma.common"
#include <ctype.h>

extern direct int  numbytes, doList, glbls, dglbls,
                   edatas, ddatas, InMacro;
extern direct char *cmdcod, AIMFlg;
extern direct unsigned d0033;

extern direct char     *rmb_ptr, *s_rmbend, *nam_ptr, *cod_end,
                       c_flg, *_if_dpth, *_ifistru, *d002d;
extern direct long nmbr_int;
extern direct char     *d0049, **s_addrs, *codsiz, **adrs_ptr,
                       *d0053, pass2, d005e, prebyt,
                       d0060, d0062, d0063, *src_char, *label, *d006a,
                       *codTbBgn, *codTbEnd, *d007c, d007e, OpCod;
extern direct CODFORM   *cod_ent;

extern direct union storer1 *opr_ptr;

extern char d0791[], *optb_ptr;

extern direct JMPTBL *jmp_ptr;
extern JMPTBL CnstTbl[], d03b6[], _if_tbl[];

extern CODFORM s_bsr, s_lbr, s_rmb, data_equ, s_rmb3, s_nam;

extern char lbl_nam[];
int    asm_dirct(), do_ifs(), do_endc(),
       equset(), setmac(), noMac(),
       _psect(), do_csec(), setrmb3(),
       l_brnch(), cc_stuff(), int_stuf(),
       chr_stuf(), bit_stuf(), no_opcod(),
       lea_s(), tfr_exg(), stk_stuf(),
       lb_(), do_brnch(), equset(),
       asm_dirct(), l0ef0(),
       codsetup(), setsect(), q_immed(),
       do_md(),do_tfm(), do_band(),
       do_aim(), do_divd(), do_addr(),
       chr_ef();

JMPTBL drectives[] ={
       asm_dirct, do_ifs, do_endc,
       equset, setmac, noMac
};

JMPTBL j_secs[] = {
       _psect, do_csec,
       setrmb3, asm_dirct
};

JMPTBL codtabl[] = {
       l_brnch,   cc_stuff,  int_stuf,
       chr_stuf,  bit_stuf,  no_opcod,
       lea_s,     tfr_exg,   stk_stuf,
       lb_,       do_brnch,  equset,
       asm_dirct, do_csec,   q_immed,
       do_md,     do_tfm,    do_band,
       do_aim,    do_divd,   do_addr,
       chr_ef
};

JMPTBL d035c[] = {
        equset, l0ef0,
        equset, codsetup
};

JMPTBL d0364[] = { equset, setsect };

int  d07b1;
long rofhdloc, d07b7, d07bb, d07bf;

int is_pass1();

l_brnch()            /* lbra & lbsr */
{
   numbytes = 3;
   l0ff5();
}

do_aim()              /* aim, oim, tim, eim  */
{

 char acod = OpCod,
      itm;

   AIMFlg = 1;
   if ( cc_stuff() ) {              /* first, get memory byte */
      if ( *src_char == ',' ) {
         ++src_char;
         ++(char *)opr_ptr;       /* Bump union ptr by one byte */
                                  /* to allow for extra byte    */
         return bit_stuf();
      }
   }
   return 0;
}

do_band()
{
  char bitpchr,
       namhold[10],
       *sr_tmp;
  unsigned bitpos;
  int  count;
  char *boff ="01234567CVZNIHFE";

   numbytes = 4;

   switch (getreg(0)) {
      case 0x08:           /* accA */
         opr_ptr->C_Byt[0] |= 0x40;
         break;
      case 0x09:           /* accB */
         opr_ptr->C_Byt[0] |= 0x80;
         break;
      case 0x0a:           /* CC   */
         break;            /* default */
      default:
         return bd_rgnam();
   }
   if ( *src_char == '.' ) {
      bitpchr = *(++src_char);
      if ( islower(bitpchr) ) {
         bitpchr = _toupper(bitpchr);
      }
      if (bitpos = strchr( boff,bitpchr ) ) {
         ++src_char;
         bitpos -= (int)boff;
         if ( ((opr_ptr->C_Byt[0]) && (bitpos<8)) || !(opr_ptr->C_Byt[0]) ) {
            if ( bitpos > 7 ) {
               bitpos -= 8;
            }
            opr_ptr->C_Byt[0] |= bitpos;
            if ( *src_char == ',' ) {
               ++src_char;
               if ( *src_char == '<' ) {
                  ++src_char;
               }
               count=0;
               while ( (count < 9 ) && (namhold[count] = *(src_char++)) &&
                              (namhold[count] != '.') ) {
               ++count;
               }
               namhold[count] = '\0';
               sr_tmp = --src_char;   /* Tmp save src_char */
               src_char = namhold;
               if ( getNmbr() == 0) {
                  src_char = sr_tmp;
                  return (e_report("bad number for band operation"));
               }
               src_char = sr_tmp;
               if ( (nmbr_int > -256) && (d0033 < 256) ) {
                  d0033 = nmbr_int;
                  l143e();
                  l1389();
                  opr_ptr->C_Byt[1] = d0033;
                  if ( *src_char == '.' ) {
                     ++src_char;
                     if (bitpos = strchr( boff,*src_char ) ) {
                        ++src_char;
                        bitpos -= (char)boff;
                        if ( bitpos < 8 ) {
                           opr_ptr->C_Byt[0] |= (bitpos <<3);
                           return 1;
                        }
                     }
                  }
               }
            }
         }
      }
   }
   return ilAdrMod();
}
      
cc_stuff()            /* orcc, andcc, & cwai */
{
   numbytes = 2;
   if ( immediat() ) {
      d0063 |= 8;
      l2387();
      opr_ptr->C_Byt[0] = nmbr_int;
      return 1;
   }
   ilAdrMod();
}

q_immed()      /* does q register (needed for long usage on immediate mode */
{
   if ( immediat() ) {
      numbytes +=4;
      do_long();
      opr_ptr->q_long = nmbr_int;
      l0fe0();
   }
   else {
      prebyt = 0x10;      /* all other modes require prebyte */
      cmdcod = &prebyt;
      ++numbytes;
      OpCod = 0xcc;        /* Opcode is also different */
      regofst();
   }
}

do_md()
{
   if ( !immediat() ) {
      return 0;
   }
   ++numbytes;
   l2387();
   opr_ptr->C_Byt[0] = nmbr_int;
   return 1;
}

int_stuf()            /* add's etc for 16-bit stuff */
{
   if ( immediat() ) {
      numbytes += 2;
      l2369();
      opr_ptr->C_Int[0] = nmbr_int;
      l0fe0();
   }
   else {
      regofst();
   }
}

         /* add, sub, cmp, ld */
         /* for special cases that include "E" & "F" regs 
            if "E" or "F" not found, falls through to chr_stuf() */
chr_ef()          /* 8-bit processes */
{
 int lngreg = 0;
   switch ( *d006a ) {
      case 'e':
         *(--cmdcod) = 0x11;
         ++numbytes;
         break;
      case 'f':
         *(--cmdcod) = 0x11;
         ++numbytes;
         OpCod |= 0x40;
         break;
      default:
         return(chr_stuf());  /* then check for standard regs */
   }
   return poprnd(lngreg);
}

         /* sbc,and, bit, st, eor, adc, etc */
chr_stuf()          /* 8-bit processes */
{
 int lngreg = 0;
   switch ( *d006a ) {
      case 'd':
         *(--cmdcod) = 0x10;
         ++numbytes;
         lngreg = 1;
         break;
      case 'b':
         OpCod |= 0x40;
         break;
      case 'a':
         break;
      default:
         return(bd_rgnam());
   }
   return poprnd(lngreg);
}

poprnd(_lngreg)
 int _lngreg;
{
   if ( immediat() ) {
      ++numbytes;
      if ( _lngreg ) {
         ++numbytes;
         l2369();
         opr_ptr->C_Int[0] = nmbr_int;
      }
      else {
         d0063 |= 8;
         l2387();
         opr_ptr->C_Byt[0] = nmbr_int;
      }
      return l0fe0();
   }
   else {
      return regofst();
   }
}

do_divd()
{
  return poprnd(0);
}

bit_stuf()
{
   if ( (OpCod != 1) && !AIMFlg && (OpCod != 5) && (OpCod != 0x0b) &&
                                           (OpCod != 0x0e) && *d006a ) {
      switch ( *d006a ) {
         case 'w':
               /* If not neg, asr, lsl, asl */
            if ( OpCod  && (OpCod != 7) && (OpCod != 8) ) {
               OpCod |= 0x50;
               *(--cmdcod) = 0x10;
               ++numbytes;
               break;
            }
            return( bd_rgnam() );    /* non-allowed modes */
         case 'd':
            OpCod |= 0x40;
            *(--cmdcod) = 0x10;
            ++numbytes;
            break;
         case 'a':
            OpCod |= '\x40';
            break;
         case 'b':
            OpCod |= '\x50';
            break;
         case 'e':
         case 'f':
            if ( (OpCod == 3) || (OpCod >= 0x0a) ) {
               OpCod |= ( (*d006a == 'e') ? 0x40 : 0x50 );
               *(--cmdcod) = 0x11;
               ++numbytes;
               break;
            }
         default:
            return( bd_rgnam() );
      }
      return 1;
   }
   if ( regofst() ) {
      if ( OpCod & 0xe0 ) {
         OpCod |= 0x40;
      }
      return 1;
   }
   return 0;
}

no_opcod()    /* No opcode, just a null subroutine */
{
   return 1;
}

lea_s()       /* leax, leas, etc. */
{
   if ( regofst() ) {
      return 1;
   }
   else{
      ilAdrMod();
   }
}

do_tfm()
{
 int  rg0, rg1;
 char nxtc;
 int  sgn0, sgn1;

   sgn0 = sgn1 = 0;
   numbytes += 1;
   if ( ((rg0 = getreg(0)) >= 0x100) && (rg0 <= 0x104) &&
           (((nxtc=*src_char) == ',') || (nxtc=='+') || (nxtc=='-')) ) {
      if ( nxtc != ',' ) {
         ++src_char;
         if ( nxtc == '+' ) {
            ++sgn0;
         }
         else {
            --sgn0;
         }
         if ( *src_char != ',' ) {
            return bdrglist();
         }
      }
      ++src_char;
      if ( ((rg1 = getreg(0)) >= 0x100) && (rg1 <= 0x104) ) {
         if ( ((nxtc=*src_char) == '+') || (nxtc == '-') ) {
            ++src_char;
            if ( nxtc == '+' ) {
               ++sgn1;
            }
            else {
               --sgn1;
            }
         }
         if ( sgn0 || sgn1 ) {
            if ( (sgn0 > 0) && (sgn1 > 0) ) {
               OpCod = 0x38;
            }
            else {
               if ( (sgn0 < 0) && (sgn1 < 0) ) {
                  OpCod = 0x39;
               }
               else {
                  if ( (sgn0 > 0) && (sgn1 == 0) ) {
                     OpCod = 0x3a;
                  }
                  else {
                     if ( (sgn0 == 0) && (sgn1 > 0) ) {
                        OpCod = 0x3b;
                     }
                     else {
                        return bdrglist();
                     }
                  }
               }
            }
         }
         opr_ptr->C_Byt[0] = ( rg0<<4 | rg1 );
         return 1;
      }
   }
   return bdrglist();
}

static tfr_exg()
{
 int rg0 = 0,         /* First register named in tfr, exg   */
     rg1;             /* Second register  */
   numbytes = 2;

                          /* First, take care of tfr 0,R   */
   if ( (OpCod == 0x1f) && (*src_char == '0') ) {
      rg0 = 0x0c;   /* tfr 0,R code */
      ++src_char;
   }

   if ( (rg0 ||(rg0 = getreg(0))) && (*src_char == ',') ) {
      ++src_char;
      if ( rg1 =getreg(0) ) {
         if ( (rg0==0x0c) || (((rg0^rg1) & 8) == 0) ) {
            opr_ptr->C_Byt[0] = ( rg0<<4 | rg1 );
            return 1;
         }
         else {
            return(e_report( "register size mismatch" ));
         }
      }
   }
   return bdrglist();
}

do_addr()
{
 int rg0, rg1;
   numbytes = 3;
   if ( (rg0 = getreg(0)) && (*src_char == ',') ) {
      ++src_char;
      if ( rg1 =getreg(0) ) {
         if ( rg1 != 0x0a ) {
            opr_ptr->C_Byt[0] = ( rg0<<4 | rg1 );
            return 1;
         }
         else {
            return (e_report( "storing to CCR" ));
         }
      }
   }
   return bdrglist();
}

stk_stuf()   /* Psh.. pul.. on/off stacks */
{
int var2;
   numbytes = 2;
   skp_dlm();
   while ( var2=getreg(1) ) {
      opr_ptr->C_Byt[0] |= var2;
      if ( *src_char != ',') {
         return 1;
      }
      ++src_char;
   }
   bdrglist();
}

lb_()              /* Long branches */
{
   numbytes = 4;
   if ( cod_ent = findcmd( &(lbl_nam[1]), &s_bsr, cod_end ) ) {
      OpCod = cod_ent->opcode;
      l0ff5();                   /* in part4.c */
      return;
   }
   else {
      e_report( "bad mnemonic" );
   }
}

do_brnch()
{
int var2;
   numbytes = 2;
   if ( getNmbr() ) {
      if ( pass2 ) {
         var2 = nmbr_int - (unsigned)codsiz -2;
         d0063 |= '\x88';
         l143e();
         if ( d0791 == optb_ptr ) {
            if ( (var2 > 127) || (var2 < -128) ) {
               var2 = -2;
               e_report( "branch out of range" );
            }
         }
         else {
            l1389();
         }
         opr_ptr->C_Byt[0] = var2;
      }
      return 1;
   }
   return 0;
}

          /* equset(): handles fcc's, fcb's , etc */
equset()
{
   numbytes = 0;
   (*CnstTbl[OpCod].fn)();
}

asm_dirct()   /* setdp, org, etc */
{
   numbytes = 0;
   (*d03b6[OpCod].fn)();
}


do_ifs()     /* handles if statememts */
{
   numbytes = 0;
   ++_if_dpth;
   if ( _if_tbl[OpCod].fn != is_pass1 ) {
      if ( getNmbr() == 0 ) {
         return 0;
      }
      if ( d0791 != optb_ptr ) {
         ilExtRef();
         return;
      }
   }
   if ( (*_if_tbl[OpCod].fn)() == 0 ) {
      ++_ifistru;
   }
   doList &= ( c_flg > 0 );
   return 1;
}

ilExtRef()
{
   e_report( "illegal external reference" );
}

do_endc()
{
   numbytes = 0;
   if ( _if_dpth ) {
      if ( OpCod == 0 ) {
         --_if_dpth;
         if ( _ifistru ) {
            --_ifistru;
         }
      }
      else {
         (_ifistru) ? --_ifistru : ++_ifistru;
      }
      doList &= ( c_flg>0 );
      return 1;
   }
   e_report( "conditional nesting error" );
}

_psect()
{
   codsetup();
   do_psect();
   codsiz = ddatas = dglbls = edatas = glbls = 0;
   return 1;
}

             /* sets up for findcmd() for all CPU directives */
codsetup()
{
   numbytes = 0;
   codTbBgn = &s_lbr;
   codTbEnd = rmb_ptr;
   jmp_ptr = codtabl;
   d007c = &d007e;
   d005e = 4;
   d0060 = 0xa2; /* 162; */
   d0062 = 0x20;
   s_addrs = &codsiz;
   d0053 = 0;
   return 1;
}

             /* sets up for csect stuff */
do_csec()
{
   numbytes = 0;
   codTbBgn = &s_rmb;
   codTbEnd = s_rmbend;
   jmp_ptr = d035c;
   d007c = 0;
   d005e = 6;
   d0060 = (d0060 & '\x2' ) | '\x80';
   s_addrs = d0062 = 0;
   adrs_ptr = d0053 = &d0049;
   d0049 = 0;
   if ( skp_dlm() ) {
      if ( getNmbr() == 0 ) {
         return 0;
      }
      if ( optb_ptr != d0791 ) {
         ilExtRef();
         return;
      }
      d0049 = nmbr_int;
   }
   return 1;
}

setrmb3()
{
   numbytes = 0;
   codTbBgn = &s_rmb3;
   codTbEnd = nam_ptr;
   jmp_ptr = d0364;
   d005e = 0;
   if ( is_dp() ) {
      d005e = 2;
   }
   return 1;
}

l0ef0()
{
   adrs_ptr = d0053;
   if ( d0060 & 2 ) {
      codsetup();
   }
   else {
      setsect();
   }
}

               /* sets up a macro definition */
setmac()
{
   if ( InMacro ) {
      nstmacdf();
   }
   else {
      if ( label == 0 ) {
         e_report( "label missing" );
      }
      else {
         l2069(8);
         if ( pass1 ) {
            newMac();
         }
         InMacro = 1;
      }
   }
}

noMac()
{
   e_report( "ENDM without MACRO" );
}
