#include <ctype.h>
#include "rma.common"

#define _ischar(c) (_chcodes[c]&(_DIGIT|_LOWER|_UPPER|_CONTROL))

extern direct long     nmbr_int;
extern direct unsigned hadarrow, is_extrn;
extern direct char **s_addrs, *codsiz, pass2, d005e, d005f, *src_char;
extern direct int glob_cnt;
extern direct char lbltyp, *d0078;
extern direct struct symblstr *smbl_dsc;

extern char    *alt_lbl;
extern struct symblstr d0587;

extern struct symblstr *d078f, **d07b1;
extern struct optns d0791[10], *optb_ptr;

mov_lbl(parm)
 char *parm;
{
 int var;

   if ( isalpha( *src_char ) ) {
      var = 9;
      while ( (var-- > 0) && ( _ischar(*src_char) ) ) {
         *(parm++) = *(src_char++);
      }
      *parm = '\0';
      while ( _ischar( *src_char ) ) {
         ++src_char;
      }
      return 1;
   }
   return 0;
}

l1e4d()
{
 register char *reg;
 char *var;

   smbl_dsc = 0;
   if ( mov_lbl( &alt_lbl ) == 0 ) {
      return 0;
   }
   if ( *src_char == ':' ) {
      ++src_char;
      lbltyp |= 4;
   }
   var = l227f( &alt_lbl, &smbl_dsc );
   reg = smbl_dsc;

   if ( pass1 ) {
      if ( var ) {
         smbl_dsc = reg = l2210 ( &alt_lbl, &smbl_dsc, var );
      }
      if ( (reg->w1 & 0x80) == 0 ) {
         reg->smbltyp = (reg->smbltyp & 0xf0) | d005f;
         reg->w1 |= lbltyp;
         if ( s_addrs) {
            reg->s_ofst = *s_addrs;
         }
      }
      else {
         if ( (reg->smbltyp & 0x0f) != LT_SET ) {
            reg->w1 |= 0x40;
         }
      }
      if ( (reg->w1 & 0xc6) == 0x86 ) {
         ++glob_cnt;
      }
      return 1;
   }
   if ( var || ((reg->w1 & 0x80) == 0) ) {
      errexit( "symbol lost!?");
   }
   if ( ((reg->w1 &= 0xef) & 0x40) ) {
      e_report( "redefined name");
      return 1;
   }
   else {
      if ( s_addrs && ((reg->smbltyp & 0x0f) == d005e) &&
                      (reg->s_ofst != (int)(*s_addrs)) ) {
         phaserr();
         reg->s_ofst = *s_addrs;
      }
   }
   return 1;
}

l1f63()
{
 struct ref_str *var1;
 int cmp_case,
     var3;
 register struct symblstr *reg;

   cmp_case = l227f( &d0587, &smbl_dsc );
   reg = smbl_dsc;
   if ( cmp_case ) {
      if ( pass1 ) {
         reg = smbl_dsc = l2210( &d0587, &smbl_dsc, cmp_case );
      }
      else {
         errexit( "new symbol in pass two" );
      }
   }
   var3 = reg->smbltyp & 0x0f;
   if ( (reg->w1 ^ 0x80) & 0xa0 ) {
      is_extrn = 1;
      if ( pass1 ) {
         reg->w1 |= 0x10;
      }
      if ( (reg->w1 & 0x80) && ((var3 == LT_EQU) || (var3 == LT_SET)) ) {
         for ( var1 = reg->wrd; var1; ) {
            optb_ptr->optn = var1->r_flag;
            l204a( optb_ptr->optadr = var1->r_offset);
            ++optb_ptr;
            var1 = var1->nxt_opt;
         }
      }
      else {
         optb_ptr->optn = 0;
         (optb_ptr++)->optadr = reg;
         l204a( reg );
      }
   }
   else {
      if ( pass2 ) {
         if ( reg->w1 & 0x10 ) {
            l204a( reg );
         }
      }
   }
   if ( var3 == 7 ) {
      nmbr_int = 0;
   }
   else {
      nmbr_int = reg->s_ofst;
   }
   return 1;
}

l204a(parm)
 char *parm;         /* parm is some type of struct ptr */
{
 register char *reg = parm;

   if ( hadarrow == 0 ) {
      if ( (*reg & 6) == 2 ) {
         hadarrow = 1;
      }
      else {
         hadarrow = -1;
      }
   }
}

l2069(parm)
 char parm;
{
   if ( ((smbl_dsc->w1) & 0x40) == 0 ) {
      if ( (parm != LT_SET) && ( (smbl_dsc->smbltyp & 0x0f) == LT_SET) ) {
         (smbl_dsc->w1) |= 0x40;
      }
      else {
         smbl_dsc->smbltyp = ((smbl_dsc->smbltyp & 0xf0) | parm );
      }
   }
}

l20a4(parm)
 struct symblstr *parm;
{
 struct optns *var1;
 struct ref_str *var2;
 char *var3;
 register struct symblstr *reg = smbl_dsc;

   var3 = reg->smbltyp & 0x0f;
   if ( optb_ptr == d0791 ) {
      if ( ((reg->smbltyp & 4) != 0) && ((reg->w1 & 0x20) != 0) ) {
         reg->w1 &= 0xdf;
      }
      else {
         if ( (pass2 > 0) && (parm != reg->s_ofst) &&
                        !(reg->w1 & 0x40) && (var3 != LT_SET) ) {
            phaserr();
         }
      }
   }
   else {
      if ( pass1 ) {
         if ( var3 == LT_EQU ) {
            reg->w1 |= 0x20;
            while ( optb_ptr > d0791 ) {
               --optb_ptr;
               l21c9( reg, optb_ptr->optn, optb_ptr->optadr );
            }
         }
      }
      else {
         if ( var3 == LT_EQU ) {
            var2 = reg->wrd;
            var1 = optb_ptr;
            while ( var2 && (d0791 < var1) ){
               --var1;
               if ( (var2->r_offset != var1->optadr) ) {
                  break;
               }
               var2 = var2->nxt_opt;
            }
            if ( (var2 != 0) || (d0791 != var1) ||
                            (reg->s_ofst != (int)parm)  ) {
               phaserr();
            }
            else {
               if ( reg->w1 & 4 ) {
                  var2 = reg->wrd;
                  while ( var2 ) {
                     if ( ( (var2->r_offset->w1) & 0x42) == 0 ) {
                        ilExtRef();
                     }
                     var2 = var2->nxt_opt;
                  }
               }
            }
         }
         else {
            ilExtRef();
         }
      }
   }
   reg->s_ofst = parm;
   return;
}

static phaserr()
{
   e_report( "phasing error" );
}

l21c9( param1, param2, param3 )
 struct symblstr *param1;
 char param2;
      *param3;
{
 register struct ref_str *reg;

/*   reg = getmem(5);*/
   reg = getmem( sizeof(struct ref_str) );
   reg->r_flag = param2;
   reg->r_offset = param3;
   reg->nxt_opt = param1->wrd;
   param1->wrd = reg;
   return;
}

      /* straight asm, how do we do otherwise ??? */
#asm
skp_dlm: ldx src_char
l21e7 ldb ,x+
 beq l21ef
 cmpb #$20
 beq l21e7
l21ef sex
 leax -1,x
 stx src_char
 rts
#endasm

l21f5( param )
 struct symblstr *param;
{
 register struct symblstr *reg = param->lastsmbl;

   if ( param->w1 & 8 ) {
      while ( reg->nxtsmbl ) {
         reg = reg->nxtsmbl;
      }
   }
   return reg;
}

l2210(param1,param2,cmp_cas)
 struct symblstr *param1, **param2;
 int cmp_cas;
{
 register struct symblstr *reg;
 struct symblstr *var;

   if ( d078f ) {
      reg = d078f;
      d078f = d078f->nxtsmbl;
      reg->nxtsmbl = reg->wrd = reg->smbltyp = reg->w1 = reg->s_ofst = 0;
   }
   else {
      reg = getmem(20);
   }
   if ( var = *param2 ) {
      if ( cmp_cas < 0 ) {
         reg->lastsmbl = var;
         var->nxtsmbl = reg;
      }
      else {
         reg->lastsmbl = var->lastsmbl;
         var->lastsmbl = reg;
         var->w1 |= 8;
      }
   }
   else {
      *d07b1 = reg;
      reg->lastsmbl = 0;
   }
   strcpy( reg->symblnam, param1 );
   return reg;
}

l227f(tbl,tptr)         /* var = l227f( alt_lbl, &smbl_dsc )        */
 struct symblstr *tbl, **tptr;
{
 int cmp_case = 1;

 {
  int tbl_len;                       /* just for this subloop */
  register char *reg = (char *)tbl;
   tbl_len = 0;

   do {
      tbl_len += *reg;
   } while ( *(++reg) != 0 ) ;

   d07b1 = ((tbl_len & 0x3f)<<1) + d0078;
 }

 { register struct symblstr *reg;
   if ( reg = *tptr = *d07b1 ) {
      do {
         if ( (cmp_case = strcmp( tbl, ((*tptr= reg)->symblnam) )) < 0 ) {
            reg = reg->nxtsmbl;
         }
         else {
            if ( (cmp_case <= 0) || ((reg->w1 & 8) == 0) ) {
               break;
            }
            reg = reg->lastsmbl;
         }
      } while ( reg );
         
   }
   return cmp_case;
 }
}

getmem(memreq)
 int memreq;
{
 int memgot;

   if ( (memgot = sbrk( memreq)) != -1 ) {
      return memgot;
   }
   else {
      errexit( "symbol table overflow" );
   }
}
   
