/* Part9.c - for "RMA"

 * Most of these seem to be MACRO - related
 */

#include "rma.common"
#include <stdio.h>
#include <ctype.h>

         /*   "place" for fseek     */
#define BEGIN 0
#define HERE 1
#define END 2

struct macro_ptr {
   FILE *m_ptr;
   long PrevMpos;
   int fi1,
       fi2;
} MacPtrs[8];

                       /* Macro Descriptor */
typedef struct macdescr {
   struct macdescr *LastMac;   /* Address of previous macro descriptor   */
   struct symblstr *MSblPtr;   /* Ptr to symbol table   ?????????        */
   FILE *MWrkFil;              /* File descriptor for macro work file    */
   long MacStart;              /* Address in work file for macro's begin */
} MACDSCR;

extern direct unsigned _ifistru, listlin;
extern direct char x_flg, pass2, tmpnam;
extern direct char *src_char, *label, *operatr, *oprand;
extern direct struct symblstr *smbl_dsc;
extern direct int InMacro, MacFlag, d00da, now_mac;
extern direct int d00d8;
extern char d0821;

direct FILE *macfp1, *macfp2;        /* d00dc, d00de */

   /* NOTE: study this: I THINK that d00e0 - d0038 MAY be
            struct macro_ptr !!!!!    */
direct int  d00e0;          /* FILE *m_ptr; */
direct char *d00e2;         /* long PrevMpos;    ??????????????? */
direct int  mac_dpth;       /* D00e4 */
direct char *d00e6;         /* int fi1,     */
direct int  *d00e8;         /* fi2;         */

char *getmem();
   
newMac()                           /* l3183 */
{
 char *var;
 register MACDSCR *macdsc;

   if ( pass1 ) {
      if ( macfp1 == 0 ) {
         if ( (macfp2 = macfp1 = fopen( &tmpnam, "w+")) == 0 ) {
            errexit( "can't open macro work file" );
         }
         macfp1->_bufsiz = 512;
      }
      macdsc = getmem( sizeof(MACDSCR) );
      macdsc->LastMac = now_mac;
      now_mac = macdsc;
      macdsc->MSblPtr= smbl_dsc;
      macdsc->MWrkFil= macfp1;
      fseek( macfp1, 0l, END );
      var = smbl_dsc->symblnam;
      while ( *var ) {
         putc( *(var++), macfp1 );
      }
      putc ( '\0', macfp1 );
      if ( ferror(macfp1) ) {
         mfilerr();
      }
      macdsc->MacStart = ftell(macfp1);
   }
   return 1;
}

mcWrtLin()
{
   if ( pass1 ) {
      putfield( label, ' ' );
      putfield( operatr, ' ' );
      putfield( src_char, '\x0d' );
   }
   return 1;
}

putfield( lin, cchr )          /* l324c() */
 char *lin;
 char cchr;
{
 register char *reg;

   if ( (reg=lin) ) {
      while ( *reg != '\0' ) {
         putc( *(reg++), macfp1 );
      }
   }
   putc( cchr, macfp1 );
   if ( ferror(macfp1) ) {
      mfilerr();
   }
}

add_nul()
{
   if ( pass1 ) {
      putc ( '\0', macfp1 );
   }
   return 1;
}

/* NOTE: This MSblPtr[10] stuff is wrong!!!
         temp fix  till symblstrct gets fixed   */

McNamCmp( parm )
 char *parm;
{
 register MACDSCR *reg = now_mac;

   while ( reg ) {
      if ( parm[0] == (reg->MSblPtr)->symblnam[0] ) {
         if ( strcmp( parm, ((reg->MSblPtr)->symblnam) ) == 0 ) {
            return reg;
         }
      }
      reg = reg->LastMac;
   }
   return 0;
}

addMac( parm )
/* struct macro_ptr *parm;*/
   MACDSCR *parm;
{
 register struct macro_ptr *reg = &MacPtrs[mac_dpth++];

   if ( mac_dpth > 8 ) {
      errexit( "macro nesting too deep" );
   }
   reg->m_ptr = macfp2;
   reg->PrevMpos = ftell(macfp2);
   reg->fi1 = d00e0;
   reg->fi2 = d00e2;
   macfp2 = parm->MWrkFil;
   fseek( macfp2, parm->MacStart, BEGIN );
   if ( InMacro == 0 ) {
      ++d00da;
   }
   d00e0 = d00da;
   d00e2 = l34a8();
   MacFlag = 1;
}

decMac()
{
 register struct macro_ptr *reg = &MacPtrs[--mac_dpth];

   if ( mac_dpth  < 0 ) errexit( "asm err: macro nest" );
   macfp2 = reg->m_ptr;
   fseek( macfp2, reg->PrevMpos, BEGIN );
   d00e0 = reg->fi1;
   l35df(d00e2);
   d00e2 = reg->fi2;
}

readmacs()
{
 char mac_chr;

   while ( MacFlag ) {
      d00e6 = src_char = &d0821;

      while ( (mac_chr = getc(macfp2)) > '\0' ) {
         if ( mac_chr == '\x0d' ) {
            *d00e6 = '\0';
            if ( x_flg ) {
               ++listlin;
            }
            return 1;
         }
         if ( (_ifistru == 0) && ( mac_chr == '\\' ) ) {
            l3402( getc(macfp2) );
         }
         else {
            *(d00e6++) = mac_chr;
         }
      }
      if ( mac_dpth == 0 ) {
         MacFlag = 0;
         break;
      }
      decMac();
   }
   return 0;
}

l3402(parm)
 char parm;
{
   if ( isdigit(parm) ) {
      gArgParm( parm, 1 );
   }
   else {
      switch (parm) {
         case '@':
            *(d00e6++) = parm;
            sprintf( d00e6, "%05u", d00e0 );
            d00e6 += 5;
            break;
         case 'L':
         case 'l':
         case '#':
            sprintf( d00e6, "%02d",
                    ( parm == '#' ? *d00e2 : gArgParm(getc(macfp2), 0) ) );
            d00e6 += 2;
            break;
         default:
            *(d00e6++) = parm;
      }
   }
}

l34a8()
{
 char *var1;
 int MArgCnt, arglen;
 char mquote, argchar;
 register char *reg;

   MArgCnt = 0;
   arglen = 59;
   if ( d00e8 ) {
      reg = d00e8;
      d00e8 = *d00e8;
   }
   else {
      reg = getmem( 61 );
   }
   skp_dlm();
   oprand = src_char;
   d00d8 = 1;
   var1 = reg++;

   if ( *src_char != '\0' ) {
      while ( arglen && ((argchar = *src_char) != '\0') && (argchar != ' ') ) {
         switch ( *src_char ) {
            case ',':
               *(reg++) = '\0';
               ++MArgCnt;
               ++src_char;
               break;
            case ' ':
               goto endloop;
            case ''':
            case '"':
               mquote = *(src_char++);
               while ( ((argchar = *(src_char++)) != '\0') &&
                               (argchar != mquote) ) {
                  if ( argchar == '\\' ) {
                     argchar = *(src_char++);
                  }
                  *(reg++) = argchar;
               }
               if ( argchar == '\0' ) {
                  e_report( "unmatched quotes" );
               }
               break;
            case '\\':
               ++src_char;
               *(reg++) = *(src_char++);
               break;
            default:
               *(reg++) = *(src_char++);
         }
         --arglen;
      }
      ++MArgCnt;
   }

endloop:
   *reg = '\0';
   if ( arglen == '\0' ) {
      e_report( "macro arg too long" );
   }
   if ( MArgCnt > 9 ) {
      e_report( "too many args" );
   }
   *var1 = MArgCnt;
   return var1;
}

l35df(parm)
 int *parm;
{
   *parm = d00e8;
   d00e8 = parm;
}

gArgParm(m_count, parm2)
 int m_count;
{
 int var = 0;
 register char *reg;

   if ( (m_count -= '0') > 0 ) {
      if ( *(reg=d00e2) >= m_count ) {
         ++reg;
         while ( --m_count > 0 ) {
            while ( *(reg++) ){}
         }
         while ( *reg != '\0' ) {
            if ( parm2 != '\0' ) {
               *(d00e6++) = *reg;
            }
            ++reg;
            ++var;
         }
      }
      else {
         e_report( "no param for arg" );
      }
   }
   return var;
}

closmac()
{
   fclose(macfp1);
   unlink(&tmpnam);
}

mfilerr()
{
   errexit( "macro file error" );
}

