/* rma.c first section of "RMA" assembler program */

#include <stdio.h>
#include "rma.common"

extern direct char *bsr_ptr, *cod_end, is_W;
extern CODFORM s_lbr, s_rmb, data_equ, s_rmb3, s_nam,
               s_bsr, s_ble;
extern JMPTBL drectives[];
extern char *o_nam, d07c9[], srcnam[];
extern int *lastsrc;

direct char e_flg = ON, x_flg = ON;
direct int  pgdepth = 66,            /* d0003 listing page depth */
            pgwidth = 80;            /* d0005 listing page width */
direct FILE *s_file,                 /* D0015 */
            *o_file;                 /* D0017 */
direct int  prtpth, numbytes, d001d,
            jsrOfst, d0021, had_err;
direct unsigned d0025, d0027, _if_dpth, _ifistru;
direct unsigned listpag, listlin;    /* d002d, d002f */
direct long nmbr_int;
direct unsigned d0033, hadbrkt, hadarrow;
direct char *d0039[2];                 /*  ???   */
direct int  doList, is_extrn, glbls, dglbls, edatas, ddatas;
direct char *d0049, **s_addrs, *codsiz, **adrs_ptr;
direct int  d0051, *d0053;
direct int  glob_cnt, ref_cnt,         /* D0055, D0057 */
            comn_cnt, locl_cnt;
direct char pass2,                     /* D005d */
            d005e, d005f, d0060, lbltyp, 
            d0062, d0063;
direct char *src_char,           /* d0064 originally */
            *label, *operatr, *d006a, *oprand,
            *coment;
direct int  (**jmp_ptr)();
direct CODFORM *cod_ent;
direct char *codTbBgn, *codTbEnd,
            *d0078,
            *smbl_dsc,              /* D007a */
            *d007c;
direct char d007e, d007f[7], *d0086[6],
            d0092, d0093[7], *d009a[6],
            d00a6, d00a7[7], *d00ae[6],
            prebyt, OpCod;
direct union storer1 C_Oprnd, *opr_ptr;
direct char AIMFlg;
direct int  undeflbl;
direct char c_flg, ff_flg, g_flg, d00c4,
            listflg, listON, d00c7,
            oflg, s_flg,r_keep;                /* D00c8, D00c9 */
direct int  list_lin,                   /* D00ca */
            cmdcod, InMacro, MacFlag,
            d00d2, d00d4, now_mac, d00d8,
            d00da;

char tmpnam[30]="rma.tmp";    /* d00ea starts here at "tmpnam" */
char     alt_lbl[10],
         lbl_nam[10];
char cmntlen[10];     /* To hold " %1.xs val for comment length */
struct symblstr d0587;
char namxtra[110],            /* extra bytes for "nam" usage ?????? */
     _ttl[120];
char d0681[10], reptFpos[4], d068f[256];
struct symblstr *d078f;
struct optns d0791[10], *optb_ptr;

main(argc,argv)
 int argc;
 char *argv[];
{
 int *rd_fil;
   getopts(argc,argv);
   if ( listflg ) {
      listON = ON;
   }
   strcpy(cmntlen," %1.");  /* Initialize cmntlen */
   d007e = 4;
   d0092 = 3;
   d00a6 = 1;
   d007f[0] = d0093[0] = d00a7[0] = 2;
   if ( oflg ) {
      o_file = f_opn(o_nam, "w");
   }
   rd_fil = srcnam;

   while ( rd_fil < lastsrc ) {
      s_file = f_opn( *rd_fil,"r" );
      pass2 = d0086[0] = d009a[0] = d00ae[0] =
                             d0587.symblnam[0] = _ttl[0] = 0;
      readfil();              /* PASS 1 */
      rewind(s_file);
      pass2=TRUE;
      readfil();              /* PASS 2 */
      l2cf1();
      wrt_refs();
      if ( fclose(s_file) != 0 ) {
         e_report( "file close error" );
      }
      if ( s_flg > 0 ) {
         do_symtb();
      }
      ++rd_fil;
   }
   closmac();
   if ( had_err ) {
           /* if an output file exists, and "keep r-file" has not
              been specified then delete it
           */
      if ( o_file && (r_keep<1) ) {
         fclose(o_file);
         unlink(o_nam);
      }
      exit(1);
   }
   exit(0);
}

readfil()
{
   char var1;
   setsect();
   had_err = d0025 = FALSE;
   d0078 = d068f;
   _if_dpth = _ifistru = d0027 = listlin = listpag = list_lin = d00da = 0;
   if ( pass2 && listON && ( listflg > 0 )  ) {
      doList = ON;
   }
   else {
      doList = OFF;
   }
   prnthdr();
   while ( getUseLn() ) {
      if ( AsmblLin() ) {
         coment = src_char;
      }
      listline();
   }
   if ( pass2 && listON ) {
      if ( ff_flg ) {
         putc ( '\f', prtpth );
      }
      else {
         while ( list_lin < pgdepth ) {
            putc( '\n', prtpth );
            ++list_lin;
         }
      }
   }
}

#define TRM_0064 if ( oprand == src_char ) { oprand=0; } else { if ( oprand != 0 ) { if (*src_char) { *src_char++=0; skp_dlm();}}} return 1;

char *findcmd(),
     l1e54(),
     l21e4();

static AsmblLin()
{
char  var2;
char *var1;
   numbytes = d0033 = d001d = d0021 = hadarrow =
                              d0039[0] = undeflbl = is_W = AIMFlg = 0;
   opr_ptr = &C_Oprnd;
   if ( (adrs_ptr = s_addrs) != 0 ) {
              /* Note: see if the two lines can be integrated such that:
                  leax >d0051  \  stx adrs_ptr  \ ldd [s_addrs,y] \ std ,x */
      adrs_ptr = &d0051;
      d0051 = *s_addrs;                   /* s_addrs is char * ?? */
   }
   label = operatr = oprand = coment = cmdcod = 0;
   d005f = d005e;  lbltyp = d0060;  d0063 = d0062;
   optb_ptr = &d0791[0];
   if ( pass2 && listON && (listflg > 0) && (_ifistru==0 || c_flg>0) ) {
         doList = ON;
   }
   else {
      doList = OFF;
   }
   d00d8 = 0;
   if ( MacFlag && (x_flg <= OFF) ) {
      doList = OFF;
   }
   if ( ((var2= *src_char) == '\0')  || (var2 == '*') ) {
      return 1;
   }
      if ( var2 != ' ' ) {
         label = src_char;
         if ( ( !InMacro ) && (!_ifistru) && (!d00d4) ) {
            if ( l1e4d() == 0 ) {
               e_report( "bad label" );
               return;
            }
         }
         else {
            while ( (var2=*src_char) != '\0' ) {
               if ( var2 == ' ' ) {
                  break;
               }
               ++src_char;
            }
         }
      if ( *src_char == ' ' ) {
         *src_char++ = '\0';
      }
   }
   if ( (var2 = skp_dlm()) == 0 ) {
      return(1);
   }
   if (mov_lbl(lbl_nam) != 0 ) {
      operatr = lbl_nam;
      skp_dlm();
      if ( (d00d4==0) && ((var1=McNamCmp(lbl_nam))!=0) ) {
         if ( InMacro!=0 ) {
            mcWrtLin();
            return 1;
         }
         else {
            addMac(var1);
            return 1;
         }
      }
      else {
         if ( (cod_ent=findcmd( lbl_nam, &s_nam, bsr_ptr )) !=0 ) {
            jsrOfst = cod_ent->tofst & '\x0f';
            if ( d00d4 != 0 ) {
               if ( (jsrOfst == 0) && (cod_ent->opcode == '\x0b') ) {
                     /* line was "endr" */
                  return( end_rept() );
               }
               else {
                  doList = OFF;
                  return 1;
               }
            }
            else {                          /* in case of macro stuff */
               if ( InMacro != FALSE ) {
                  if ( jsrOfst == 4 ) {
                     return( nstmacdf() );   /* can't nest macro defs */
                  }
                  if ( jsrOfst == 5 ) {                  /* if "endm" */
                     add_nul();
                     InMacro = 0;
                     return 1;
                  }
                  else {
                     mcWrtLin();
                     return(1);
                  }
               }
               if ( _ifistru !=0 ) {
                  if ( jsrOfst != 1 ) { /* if not "if" statememt */
                     if ((jsrOfst != 2) || (--_ifistru == 0) ||
                                                 (cod_ent->opcode == 0)) {
                        return 1;
                     }
                  }
                  ++_ifistru;
                  return 1;
               }
               OpCod = cod_ent->opcode;
               oprand = src_char;
   
               if ( (*drectives[jsrOfst].fn)() == 0 ) {
                 return 0;
               }
               else {
                         /* TRM_0064;*/
                  if ( oprand == src_char ) {
                     oprand=0;
                  } else {
                     if ( oprand != 0 ) {
                        if (*src_char) {
                           *(src_char++)='\0';
                           skp_dlm();
                        }
                     }
                  }
                  return 1;
               }
            }
         }
         else {
            if ( d00d4 != 0 ) {
               doList = OFF;
               return 1;
            }
            else {
               if ( InMacro != 0 ) {
                  mcWrtLin();
                  return 1;
               }
               else {
                  if ( _ifistru != 0 ) {
                     if ( (doList==OFF) || (*src_char=='\0') ) {
                        return 1;
                     }
                     else {
                        oprand = src_char;
                        while ( *(++src_char) != '\0' ) {
                           if ( *src_char == ' ' ) {
                              break;
                           }
                        }
                        if ( *src_char != 0 ) {
                           *src_char++ = '\0';
                        }
                        return 1;
                     }
                  }
                  if ( codTbBgn == &s_lbr ) {
                     if ( (lbl_nam[0] == 'b') ||
                                             (lbl_nam[0] == 'B') ) {
                        cod_ent = findcmd( lbl_nam, &s_bsr, cod_end );
                     }
                  }
                  if ( cod_ent == 0 ) {
                     cod_ent = findcmd( lbl_nam, codTbBgn, codTbEnd );
                  }
                  if ( cod_ent != 0 ) {
                     jsrOfst = cod_ent->tofst & 0x1f;
                     numbytes = 1;
                     cmdcod = &OpCod;

        /* Set up Prebyte if applicable */

                     if ( (prebyt=cod_ent->tofst & (PRE_10|PRE_11)) != 0 ) {
                        if ( (prebyt & PRE_10) ) {
                           prebyt = 0x10;
                        }
                        else {
                           prebyt = 0x11;
                        }
                        numbytes = 2;
                        cmdcod = &prebyt;
                     }
                     OpCod = cod_ent->opcode;
                     C_Oprnd.q_long = 0;
                     oprand = src_char;
                     if ( (*jmp_ptr[jsrOfst])() == 0 ) {
                        return 0;
                     }
                     else {
                        w_ocod( cmdcod, numbytes );
                                   /* TRM_0064;*/
                        if ( oprand == src_char ) {
                           oprand=0;
                        }
                        else {
                           if ( oprand != 0 ) {
                              if (*src_char) {
                                 *(src_char++)='\0';
                                 skp_dlm();
                              }
                           }
                        }
                        return 1;
                     }
                  }
               }
            }
         }
      }
   }
   coment = src_char;
   e_report( "bad mnemonic" );
}

listline()
{
 register char *regvar;
   if ( doList == OFF ) return 0;
   if ( (pgdepth-3) < list_lin ) {
      prnthdr();
   }
   doList = OFF;
   if ( d00c7 == 0 ) {
      printf("%05d", listlin);               /* Line number */
   }
   if ( label || operatr || (numbytes>0) ) {      /* l05e6 */
    int var1;
      regvar = cmdcod;

                /* Code offset */

      if ( adrs_ptr != 0 ) {
         printf( " %04x", *adrs_ptr );
      }
      else {
         fputs( "     ", stdout );
      }

      putc( undeflbl ? '=' : ' ', stdout );

                     /* Code data (if any) */

      if ( regvar != 0 ) {
         for ( var1 = 0; var1 < 5; var1++ ) {
            if ( var1 < numbytes ) {
               printf( "%02x", (*(regvar++))&0xff );
            }
            else {
               fputs( "  ", stdout );
            }
         }
      }
      else {
         fputs( "          ", stdout );
      }
   }
   if ( label || operatr ) {                            /* l0689 */
      if ( label == 0 ) {
          label = "\0";
      }
      if ( operatr == 0 ) {
          operatr = "\0";
      }
      if ( oprand == 0 ) {
          oprand = "\0";
      }

               /* Label-Operator-Operand */

      printf( "%c%-8s %-5s ", (MacFlag && (d00d8==0)) ?
                                             '+' : ' ',label,operatr );
      printf( d00d8 ? "%s" : "%-10s", oprand );
   }

               /* Comment output */

   if ( coment ) {
    int llen;
      if ( label || operatr || (numbytes>0) ) {
         llen = pgwidth-39-(strlen(oprand)<=10?10:strlen(oprand));
      }
      else {
         llen = pgwidth - 7;
      }
      if ( llen > 3 ) {
         itoa(llen,&cmntlen[4]);
/*      printf( " %s", coment);*/
         printf( strcat(cmntlen,"s"), coment);
      }
   }
   putc( '\n', stdout );
   ++list_lin;
}

bdrglist()
{
   e_report( "bad register list" );
}

bd_rgnam()
{
   e_report( "bad register name" );
}

nstmacdf()
{
   e_report( "nested MACRO definitions");
}

e_report(report)
char *report;
{
   if ( pass2 ) {
      doList = 1;
      if ( (list_lin==0) || (list_lin > pgdepth-4) ) {
         prnthdr();
      }
      printf( "*** error - %s ***\n", report );
      ++list_lin;
   }
   ++had_err;
   return 0;
}

errexit( report )
char *report;
{
   fprintf( stderr, "asm: %s\n", report );
   exit(errno);
}
