/* Part 4 of "rma" assembly */

#define TRUE 1

#include <ctype.h>
#include "rma.common"

#define INDX_BYT opr_ptr->shrtlng.f_byt
/*#define AIM_INDXD if (AIMFlg) {C_Oprnd.C_Byt[0] |= 0x60;}*/
#define AIM_INDXD      /* Debugger, should be able to delete all refs to
                          this, it's apparently not needed.   */

extern direct unsigned numbytes, jsrOfst, d0021;
extern direct long     nmbr_int;
extern direct int      d0033, hadbrkt, hadarrow, d0039;
extern direct unsigned codsiz, ref_cnt, locl_cnt,
                       undeflbl;

extern direct char  **s_addrs, pass2, OpCod, AIMFlg;

extern direct unsigned d0027;
extern direct char     d0063, *src_char, *d007c;

extern direct union storer1 C_Oprnd, *opr_ptr;

extern struct optns d0791[10], *optb_ptr;

direct char is_W;       /* Flag that we are indexing off W  */

struct regstrct {
     char regnam[2],
          RType;
};

struct regstrct RegCode[] = {
      {{'A','\0'},0x02}, {{'B','\0'},0x04}, {{'C','C'}, 0x01},
      {{'D','P'}, 0x08}, {{'\xfe','\0'},0}, {{'\xfe','\0'},0},
      {{'E','\0'},0x00}, {{'F','\0'},0x00},
      {{'D','\0'},0x06}, {{'X','\0'},0x10}, {{'Y','\0'},0x20},
      {{'U','\0'},0x40}, {{'S','\0'},0x40}, {{'P','C'}, 0x80},
      {{'W','\0'},0x00}, {{'V','\0'},0x00}
};

         /* Count of entries in "regstrct" array (6309) */
#define REGCOUNT sizeof(RegCode)/sizeof(RegCode[0])

char skp_dlm();

immediat()
{
   if ( skp_dlm() == '#' ) {
      ++src_char;
      return 1;
   }
   return 0;
}

l0fe0()
{
   if ( jsrOfst & 0x40 ) {
      numbytes = 3;
      ilAdrMod();
   }
   else {
      return 1;
   }
}

l0ff5()
{
   d0063 |= 0x80;
   if ( l2369() ) {
      if ( ((opr_ptr->C_Int[0] = nmbr_int - codsiz - numbytes ) > 127) ||
       opr_ptr->C_Int[0] < -128 ) {
         d0039 = 1;
      }
      else {
         d0039 = 0;
      }
      return 1;
   }
   return 0;
}

/* getreg(PhsPul) = l102b() : Parses the Register name structure to match up 
             register bit patterns
        returns: if not PshPul
                  case not register (X,Y,U,S,PC), offset into table | 8
                  case register, offset-4 | $100
                 if PshPul
                   push/pull code for register (0 if invalid)
*/


getreg(PshPul)
 int PshPul;
{
 int  regptr;
 char var2;

   regptr =0;
   while ( regptr < REGCOUNT ) {
      if ( RegCode[regptr].regnam[0] == _toupper( *src_char ) ) {
                /* First char matched */
         if ( (var2 = RegCode[regptr].regnam[1]) ) {
                   /* second char not null, check if it matches */
            if ( _toupper( src_char[1] ) == var2 ) {
               ++src_char;              /* bump ptr for extra char */
            }
            else {
               ++regptr;        /* Bump regptr and get next */
               continue;
            }
         }
         ++src_char;
         if ( (regptr == 4) || (regptr == 5) ) {
            return 0;           /* Blank areas */
         }
         if ( PshPul == 0 ) {
            if ( regptr < 8 ) {  /* Not register (X,Y,U,S,PC) */
               return ( regptr | 8 );
            } else {
               return ( (regptr-8) | 0x0100 );
            }
         }
             /* No psh/pul for E,F,W or V
                 not needed?? RType returns correct value??  */
/*         if ( (regptr!=6) && (regptr!=7) && (regptr < 14) ) {*/
            return ( RegCode[regptr].RType );
/*         }
         else {
            return 0;
         }*/
      }
      ++regptr;                /* bump to next positin */
   }
   return 0;                   /* No match found */
}

regofst()                    /*              l10d1()                 */
{                            /* Parses indexed mode for A/B/D offset */
 char itm;

   if ( hadbrkt= ( ((itm=skp_dlm()) == '[') ? 1 : 0) ) {
      itm = *(++src_char);
   }
   if ( (itm = skparrow(itm)) == ',' ) {
      AIM_INDXD;
      return l1215();
   }
   if ( src_char[1] == ',' ) {
      switch ( _toupper(itm) ) {
         case 'A':
            INDX_BYT = 0x86;
            AIM_INDXD;
            return( (_toupper(src_char[2])=='W') ? ilAdrMod() : ckpcr() );
         case 'B':
            INDX_BYT = 0x85;
            AIM_INDXD;
            return( (_toupper(src_char[2])=='W') ? ilAdrMod() : ckpcr() );
         case 'D':
            INDX_BYT = 0x8b;
            AIM_INDXD;
            return( (_toupper(src_char[2])=='W') ? ilAdrMod() : ckpcr() );
         case 'E':
            INDX_BYT = 0x87;
            AIM_INDXD;
            return( (_toupper(src_char[2])=='W') ? ilAdrMod() : ckpcr() );
         case 'F':
            INDX_BYT = 0x8a;
            AIM_INDXD;
            return( (_toupper(src_char[2])=='W') ? ilAdrMod() : ckpcr() );
         case 'W':
            INDX_BYT = 0x8e;
            AIM_INDXD;
            return( (_toupper(src_char[2])=='W') ? ilAdrMod() : ckpcr() );
      }
   }
   getNmbr();
   d0033 = nmbr_int;
   if ( *src_char == ',' ) {
      AIM_INDXD;
      return l156b();
   }
   else {
                 /* if  no '[' && dp referencing */
      if ( (hadbrkt == 0) && (hadarrow >= 0) ) {
         if ( (hadarrow > 0) || ((d0033>>8) == d0027) ) {
                 /* if dp referencing || == DP_blk */
            return l11e8();
         }
      }
/*      if ( AIMFlg ) {
         C_Oprnd.C_Byt[0] |= 0x70;
      }*/
      return l11be();
   }
}

skparrow(s_char)
 char s_char;
{
   if ( s_char == '>' ) {
      hadarrow = -1;
   }
   else {
      if ( s_char == '<' ) {
         hadarrow = 1;
      }
      else {
         hadarrow = 0;
      }
   }
   if ( hadarrow ) {
      return ( *(++src_char) );
   }
   else {
      return ( s_char );
   }
}

ckpcr()
{
   src_char += 2;
   if ( not_pcr() ) {
      l1326();
      return;
   }
   else {
      ilIdxReg();
   }
}

l11be()
{
   numbytes += 2;
   if ( hadbrkt ) {
      INDX_BYT = 0x9f;        /* Let "C_Oprnd" be struct optns */
      opr_ptr->shrtlng.f_int = d0033;     /*   for now                   */
      l1326();
   }
   else {
      l143e();
      l1389();
      opr_ptr->C_Int[0] = d0033;
      OpCod |= 0x30;
      return 1;
   }
}

l11e8()
{
   ++numbytes;
   d0063 |= 8;
   l143e();
   l1389();
   INDX_BYT = d0033;
   if ( OpCod & 0xf0 ) {
      OpCod |= 0x10; 
   }
   return 1;
}

l1215()
{
   ++src_char;
   d0033 = 0;
   if ( *src_char == '-' ) {
      ++src_char;
      if ( *src_char == '-' ) {
         ++src_char;
         INDX_BYT = 0x83;           /*  ,--R */
      }
      else {
         l12a2();
         INDX_BYT = 0x82;           /*  ,-R  */
      }
      if ( not_pcr() ) {
         l1326();
      }
      else {
         ilIdxReg();
      }
   }
   else {
      if ( not_pcr() == 0 ) {
         pc_rel();
         return;
      }
      if ( *src_char == '+' ) {
         ++src_char;
         if ( *src_char == '+' ) {
            ++src_char;
            if ( !is_W ) {
               INDX_BYT |= 0x81;                 /*   ,R++ */
            }
            else {
               INDX_BYT |= 0x40;
            }
         }
         else {
            if ( is_W ) {
               ilIdxReg();
/*               return 0;    Replaced by above to disallow ,w+  ???? */
            }
            l12a2();
            INDX_BYT |= 0x80;                 /*   ,R+  */
         }
         return( l1326() );
      }
      else {
         l1584();
      }
   }
}

l12a2()
{
   if ( hadbrkt ) {
      ilAdrMod();
   }
   else {
      return 1;
   }
}

ilAdrMod()
{
   e_report( "illegal addressing mode" );
}

not_pcr()                             /* process 0,[reg] */
{
  char var = 0xff;

   switch ( _toupper(*src_char) ) {
      case 'X':
         var = '\0';
         break;
      case 'Y':
         var = '\x20';
         break;
      case 'U':
         var = '\x40';
         break;
      case 'S':
         var = '\x60';
         break;
      case 'W':               /* do most of processing here */
         is_W = TRUE;
                      /* ,-W  not allowed */
         if ( (INDX_BYT == 0x82) ) {
               return 0;        /* let fall through to error condition */
         }
         if ( INDX_BYT == 0x83 ) {          /* if ,--W       */
            INDX_BYT = 0xef;
         }
         else {
            INDX_BYT = 0x8f;
            if ( hadarrow ) {
               hadarrow = -1;  /* Force extended addressing if spec'd. */
            }
/*               if ( src_char[1] == '+' ) {
                  if ( src_char[2] == '+' ) {
                     src_char += 2;
                     INDX_BYT |= 0x40;
                  }
                  else {                   /* If ,W+, let caller fall 
                     return 0;                  /*    to error   
                  }
               }
               else {
                  if ( d0033 || hadarrow<0 ) {
                     INDX_BYT |= 0x01;
                     numbytes += 2;
                     opr_ptr->shrtlng.f_int = d0033;
              /* force extended addressing, no other offset modes allowed 
                     hadarrow = -1;
                  }
               }*/
         }
         ++src_char;
/*         if (hadbrkt) {
            if ( *(src_char) != ']' ) {
               return( e_report( "bracket missing" ) );
            }
            INDX_BYT ^= 0x1f;
            ++src_char;
            hadbrkt = 0;
         }*/
         return 1;
      default:
         return 0;
   }
                 /* Cleanup for an X-Y-U-S match */
   ++src_char;
   INDX_BYT |= var;
   return 1;
}

/* This was the way to get the original compilation for the above
   function (to be used after the switch, but it would not work
   without the "default" above.  For some extremely strange reason,
   the below method would always return 1, even though the assembly
   code matched the original WORD FOR WORD!!!  The above method produces
   the correct result.

   if ( var != '\xff' ) {
      ++src_char;
      INDX_BYT |= var;
      return 1;
   }
   else {
      return 0;
   }
*/

ilIdxReg()
{
   e_report( "illegal index register" );
}

l1326()
{
   OpCod |= 0x20;
   ++numbytes;
   ++d0021;
   if ( hadbrkt ) {
      if ( !is_W ) {
         INDX_BYT |= 0x10;
      }
      else {
         INDX_BYT ^= 0x1f;
      }
      if ( *src_char != ']' ) {
         e_report( "bracket missing" );
      }
      else {
         ++src_char;
      }
   }

   switch ( *src_char ) {
      case ' ':
      case '\0':
         l143e();
         l1389();
         return 1;
      default:
         ilAdrMod();
   }
}

l1389()                           /* Good module: compiles correctly */
{
 int var1,var2;

   if ( pass2 && optb_ptr > d0791 ) {
      if ( s_addrs == 0 ) {
         ilExtRef();           /* report "illegal external reference" */
         /* return; */
      }
      else {
         var1 = *s_addrs + numbytes - ( (d0063 & 8) ? 1 : 2 );

         while ( optb_ptr > d0791 ) {
          register struct symblstr *reg;
            reg = (--optb_ptr)->optadr;
            var2 = reg->smbltyp | d0063 | optb_ptr->optn;

            if ( (reg->w1 & 0x42) == 0 ) {
               undeflbl = 1;
               if ( reg->wrd == 0 ) {
                  ++ref_cnt;
               }
               l21c9(reg,var2,var1);
            }
            else {
               if ( (reg->smbltyp & 0x0f) == 7 ) {
                  l21c9(reg,var2,var1);
               }
               else {
                  ++locl_cnt;
                  l21c9(d007c,var2,var1);
               }
            }
         }
      }
   }
}

l143e()
{
 struct optns *var1;

   if ( pass2 && (optb_ptr > d0791) ) {
     register struct optns *reg;

      reg = d0791;
      while ( reg < optb_ptr ) {
         if ( l149b( reg ) == 0 ) {
            if ( l1541( reg->optadr) ) {
               var1 = reg;
               while ( ++var1 < optb_ptr ) {
                  (var1-1)->optn = var1->optn;
                  (var1-1)->optadr = var1->optadr;
               }
               --optb_ptr;
            }
            else {
               ++reg;
            }
         }
      }
   }
   return 0;
}

l149b(op)
 struct optns *op;

{
 struct optns           *var1;
 char                   *var2;
 struct optns           *var3;
 register struct optns  *regopt = op;

   if ( (var2 = regopt->optadr)[1] & 2 ) {
        /* Next line may be a kludge, FIX LATER */
      var3 = ((struct optns *)var2)->optn | regopt->optn;
      var1 = regopt;
      while ( ++var1 < optb_ptr ) {
         if ( (var2 = var1->optadr)[1] & 2 ) {

               /* NOTE: the following cast for "var3" is a temporary
                        kludge... it works, but see if can do better */

            if ( ((*var2 | var1->optn) ^ (int)var3) == 0x40 ) {
               while ( regopt+1 < var1 ) {
                  regopt->optn = (regopt+1)->optn;
                  regopt->optadr = (regopt+1)->optadr;
                  ++regopt;
               }
               while ( ++var1 < optb_ptr ) {
                  regopt->optn = var1->optn;
                  regopt->optadr = var1->optadr;
                  ++regopt;
               }
               optb_ptr = regopt;
               return 1;
            }
         }
      }
   }
   return 0;
}

l1541(parm)
 struct symblstr *parm;

{
 register struct symblstr *reg = parm;

   if ( ((reg->smbltyp & 0x0f)==4) && (reg->w1 & 2) && (d0063 & 0xb0) == 0xa0 ) {
      return 1;
   }
   return 0;
}

l156b()   /* THIS FUNCTION IS OK */
{
   ++src_char;
   if ( !not_pcr() ) {
      pc_rel();
   }
   else {
      l1584();
   }
}

l1584()
{
   if ( (hadarrow < 0) ||  ((hadarrow==0) && ((d0033>127) || (d0033<-128))) ) {
         opr_ptr->shrtlng.f_int = d0033;
         numbytes += 2;
         if ( !is_W ) {
            INDX_BYT |= 0x89;             /*      mmnn,R     */
         }
         else {
            INDX_BYT |= 0x20;
         }
         return( l1326() );
         return;
   }
   if ( !hadarrow && (d0033 == 0) ) {
      if ( !is_W ){
         INDX_BYT |= 0x84;                 /*  set  0,R  to  ,R   */
      }
      else {
         INDX_BYT &= 0x9f;
      }
      return( l1326() );
   }
   else {
      if ( (hadarrow > 0) || hadbrkt || (d0033 > 0x0f) || (d0033 < -(0x10)) ){
         opr_ptr->C_Byt[1] = d0033;
         ++numbytes;
         d0063 |= 8;
         INDX_BYT |= 0x88;
         return( l1326() );
      }
      else {
         INDX_BYT |= ( d0033 & 0x1f );
         return( l1326() );
      }
   }
}

pc_rel()                                         /* originally  l1602() */
{
   if ( (_toupper(*src_char) != 'P') || (_toupper(src_char[1]) != 'C') ) {
      return( ilIdxReg() );                        /* No match, quit */
   }

   src_char += 2;                             /* bump past "PC" string */

   if ( _toupper(*src_char) == 'R' ) {     /* if "pcr" instead of "pc" */
      ++src_char;
   }
   ++numbytes;
   d0063 |= 0x80;
   d0033 -= ( codsiz + numbytes + 1 );
   if ( hadarrow > 0 ) {
      opr_ptr->C_Byt[1] = d0033;
      d0063 |= 8;
      INDX_BYT |= 0x8c;
   }
   else {
      ++numbytes;
      opr_ptr->shrtlng.f_int = (--d0033);
      INDX_BYT |= 0x8d;
   }

   l1326();
}

