/* part 8 - for RMA */

#include <stdio.h>
#include <time.h>
#include "rma.common"
#include <ctype.h>

#define BEGIN 0                           /* fseek "place" */
#define FormFeed putc( 0x0c, prtpth );
#define CarrgRet putc ( 0x0d, prtpth );

long d03dc = 0;

struct binhead {
   long     h_sync;             /* d03e0 */
   unsigned h_tylan;            /* d03e4 */
   char     h_valid,            /* d03e6 */
            h_date[5],          /* d03e7 */
            h_edit,             /* d03ec */
            h_spare;            /* d03ed */
   unsigned h_glbl,             /* d03ee */
            h_dglbl,            /* d03f0 */
            h_data,             /* d03f2 */
            h_ddata,            /* d03f4 */
            h_ocode,            /* d03f6 */
            h_stack,            /* d03f8 */
            h_entry;            /* d03fa */
} rof_hd = { 0x62cd2387,0,0,{0,0,0,0,0},0,1,0,0,0,0,0,0,0};

static struct sgtbuf d_time;

int d07c9[12]; 
char **srcnam[32],
     d0821[256];

int  *d03fc = d07c9;
char **lastsrc = srcnam;

int  o_nam = 0;
     s_column = 0;

extern direct int pgdepth, pgwidth, rversion;
extern direct FILE *s_file, *o_file;
extern direct long nmbr_int;
extern direct unsigned listpag, listlin;
extern direct int doList;
extern direct unsigned glbls, dglbls, edatas, ddatas;
extern direct char **s_addrs;
extern direct unsigned codsiz;
extern direct int prtpth, had_err, glob_cnt, list_lin;
extern direct char oflg, ff_flg, d0060, d00c4, d00c7,
                   *ref_cnt, *comn_cnt, *locl_cnt, pass2, d005f;
extern direct int d0086, d009a, d00ae;
extern direct char *src_char;
extern direct int undeflbl;

extern struct symblstr d0587;
extern long rofhdloc, d07b7, d07bb,d07bf;
extern char _ttl[];
extern int *d068f[];

int prtSmbl(), wrtglbls(), wrtxtrns(), wrtCmmns();

getopts( _argc, _argv )     /* parse parameter line */
 unsigned _argc;
 char **_argv;
{
 char var;

   s_file = o_file = 0;
   prtpth = stdout;
                         /*   o_file += 2;*/
   ++_argv;
   while ( --_argc ) {
      if ( **_argv == '-' ) {
         src_char = *_argv + 1;
         set_opts();       /* Check to see if src_char must be passed */
         if ( (oflg) && ( (var=_toupper( src_char[-1])) != '\0') &&
               (var == 'O') && (*src_char == '=') ) {
            if ( o_nam ) {
               errexit( "too many object files" );
            }
            else {
               o_nam = ++src_char;
            }
         }
      }
      else {
         if ( lastsrc > &srcnam[31] ) {
            errexit( "too many input files" );
         }
         *(lastsrc++) = *_argv;
      }
      ++_argv;
   }
   if ( lastsrc == srcnam ) {
      errexit( "no input file" );
   }
   if ( o_nam == 0 ) {
      o_nam = ( "output.r" );
   }
}

f_opn(fna,fmo)
 char *fna, *fmo;
{
 FILE *fptr;

   if ( (fptr=fopen (fna,fmo)) == 0 ) {
      fprintf ( stderr, "\"%s\" - ", fna );
      errexit( "can't open file" );
   }
   return fptr;
}

prnthdr()    /*  Prints header for listing */
{
   if ( pass2 && doList ) {
      if ( list_lin ) {
         if ( ff_flg ) {
            FormFeed;
         }
         else {
            while ( list_lin < pgdepth ) {
               CarrgRet;
               ++list_lin;
            }
         }
      }
      getime( &d_time );
      printf( "Microware OS-9 %s  %d/%02d/%02d  %02d:%02d", "RMA - V2.0",
               d_time.t_year, d_time.t_month, d_time.t_day,
               d_time.t_hour, d_time.t_minute );
      printf( "   %-22s Page %03d\n", srcnam[0], ++listpag );
      printf( "%s - %s\n\n", d0587.symblnam, _ttl );
      list_lin = 3;
   }
}

new_pag()
{
   if ( pass2 && doList ) {
      if ( (pgdepth - 3) < list_lin ) {
         prnthdr();
      }
      CarrgRet;
      ++list_lin;
   }
}

getUseLn()
{
 char parm;
 register char *reg;

   if ( readmacs() == 0 ) {
      do {
         if ( d00c4 && (d03fc == d07c9) ) {
            printf( "Asm:" );
         }
         reg = src_char = d0821;
         while ( ( parm = getc(s_file) ) != -1 ) {
            if ( parm == '\x0d' ) {        /* Carriage Return */
               *reg = '\0';
               ++listlin;
               return 1;
           }
           *(reg++) = parm;
        }
     } while ( decS_fil() );
     return 0;
  }
  else {
     return 1;
  }
}

static decS_fil()
{
   if ( d03fc == d07c9 ) {
      return 0;
   }
   if ( fclose( s_file ) ) {
      e_report( "file close error" );
   }
   s_file = *(--d03fc);
   return 1;
}

do_symtb()
{
   printf( "\nSymbol Table\n" );
   pgwidth -= 24;
   l2e27( prtSmbl );
   if ( s_column > 0 ) {
      printf( "\n" );
   }
   printf( "\n" );
}

static prtSmbl( parm )
 struct symblstr *parm;
{
 register struct symblstr *reg = parm;

   if ( s_column > 0 ) {
      printf( "  |" );
   }
   printf( "  %-9s %02x %02x %04x",
           reg->symblnam, reg->smbltyp, (reg->w1) & 0xff , reg->s_ofst );
   if ( ((s_column = s_column+25) > pgwidth) || d00c7 ) {
      printf ( "\n");
      s_column = 0;
   }
}

do_psect()
{
 char rof_nam[16];

   if ( *src_char != '\0' ) {
    int tvar;
    register char *reg = rof_nam;

      tvar = 16;
      while ( (tvar--) && (*src_char != '\0') && (*src_char != ',') ) {
         *(reg++) = *(src_char++);
      }
      *reg = '\0';
      if ( iscomma() ) {          /* get TyLan */
         getNmbr();
         e_xtrnl();
         rof_hd.h_tylan = nmbr_int << 8;
         if ( iscomma() ) {
            getNmbr();
            e_xtrnl();
            rof_hd.h_tylan |= nmbr_int;
            if ( iscomma() ) {
               getNmbr();
               e_xtrnl();
               rof_hd.h_edit = nmbr_int;
               if ( iscomma() ) {
                  getNmbr();
                  e_xtrnl();
                  rof_hd.h_stack = nmbr_int;
                  if ( iscomma() ) {
                     getNmbr();
                     e_xtrnl();
                     rof_hd.h_entry = nmbr_int;
                  }
               }
            }
         }
      }
   }
   else {
      strcpy( rof_nam, "program" );
   }
   getime( &d_time );
   _strass( rof_hd.h_date, &d_time, 5 );
   rof_hd.h_valid = had_err;
   rof_hd.h_spare = rversion;
   rof_hd.h_glbl  = glbls;
   rof_hd.h_dglbl = dglbls;
   rof_hd.h_data  = edatas;
   rof_hd.h_ddata = ddatas;
   rof_hd.h_ocode = codsiz;
   if ( pass2 && o_file ) {
      rofhdloc = ftell( o_file ); /*  ?? o_file assumed */
      fwrite( &rof_hd, sizeof(rof_hd), 1, o_file );
      fputs( rof_nam, o_file);
      putc( '\0',o_file );
      fwrite( &glob_cnt, 2, 1, o_file );
      if ( glob_cnt ) {
         l2e27( wrtglbls );
      }
      d07bf =(d07bb = (d07b7 = d03dc = ftell( o_file )) + (long)codsiz) +
                        (long)ddatas;
   }
}

e_xtrnl()
{
   if ( pass2 && undeflbl ) {
      e_report( "no external allowed" );
   }
}

l2cf1() 
{
 unsigned var = &(rof_hd.h_valid) - (int)(&rof_hd);  /* ??????????? */

   if ( (o_file == 0) || (oflg <= 0) ) {
      return;
   }
   fseek( o_file, (rofhdloc + (long)var), BEGIN );
   putc( had_err, o_file );
   d03dc = rofhdloc + (long)var + 1;
}

w_ocod( _codaddr, _codlen )
 char *_codaddr;
 int  _codlen;
{
 register long *_codloc;

   if ( s_addrs && _codlen ) {
      *s_addrs += _codlen;
      if ( pass2 && (d0060 & 2) && o_file && (oflg >0) ) {
         if ( d005f & 4 ) {
            _codloc = &d07b7;
         }
         else {
            if ( d005f & 2 ) {
               _codloc = &d07bb;
            }
            else {
               _codloc = &d07bf;
            }
         }
         if ( d03dc != *_codloc ) {
            fseek( o_file, *_codloc, BEGIN );
         }
         fwrite( _codaddr, _codlen, 1, o_file );
         d03dc = *_codloc = *_codloc + (long)_codlen;
      }
   }
}

static l2e27( parm1 )
 int (*parm1)();
{
 int var;
 register struct symblstr *reg;

   var = 0;
   while ( var < 64 ) {
      if ( reg = d068f[var] ) {
         while ( reg->nxtsmbl ) {
            reg = reg->nxtsmbl;
         }
         do {
            (*parm1)(reg);
         } while ( reg = l21f5(reg) );
      }
      ++var;
   }
}

wrt_refs()
{
   if ( o_file ) {
      fseek( o_file, d07bf, BEGIN );
      fwrite( &ref_cnt, 2, 1, o_file );
      if ( ref_cnt ) {
         l2e27( wrtxtrns );
      }
      fwrite( &locl_cnt, 2, 1, o_file );
      if ( locl_cnt ) {
         if ( d0086 ) {
            l2fd9(d0086);
         }
         if ( d009a ) {
            l2fd9(d009a);
         }
         if ( d00ae ) {
            l2fd9(d00ae);
         }
      }
             /* Write commons if rof version > 0 */
      if ( rversion ) {
         fwrite( &comn_cnt, 2, 1, o_file );
         if ( comn_cnt ) {
            l2e27( wrtCmmns );
         }
      }
   }
}

wrtglbls( parm )
 struct symblstr *parm;
{
 register struct symblstr *reg = parm;
 int var1;
 char var2;

   if ( ((reg->w1 & 0xc6) == 0x86) && (reg->smbltyp != 7) ) {
      fputs( reg->symblnam, o_file );
      putc( '\0', o_file );
      var2 = reg->smbltyp;
      var1 = reg->s_ofst;
      fwrite( &var2, 3, 1, o_file );
   }
}

wrtxtrns( parm1, parm2, parm3 )
 struct symblstr *parm1;
 int parm2;       /* return address, really ???????? */
 int parm3;
{
 register struct symblstr *reg = parm1;
 int var1;

   if ( ((reg->w1 & 0x42)==0) && (reg->wrd) &&
             ((var1=reg->smbltyp & 0x0f) !=6) && (var1 != 5) ) {
      fputs( reg->symblnam, o_file );
      putc( '\0', o_file );
      var1 = l2fa8( reg );
      fwrite( &var1, 2, 1, o_file );
      l2fd9( reg->wrd );
   }
}

l2fa8( parm )
 struct symblstr *parm;
{
 struct ref_str *var1;
 int var2;
 register struct ref_str *reg;

   var2 = 0;
   var1 = parm->wrd;
   parm->wrd = 0;
   while ( reg = var1 ) {
      var1 = reg->nxt_opt;
      reg->nxt_opt = parm->wrd;
      parm->wrd = reg;
      ++var2;
   }
   return var2;
}

static l2fd9( parm )
 struct ref_str *parm;
{
 register struct ref_str *reg = parm;

   while ( reg ) {
      fwrite( reg, 3, 1, o_file );
      reg = reg->nxt_opt;
   }
}

wrtCmmns( parm )
 struct symblstr *parm;
{
 register struct symblstr *reg = parm;
 int var;

   if ( ((reg->w1 & 0xc6) == 0x86) && ((reg->smbltyp & 0x0f) == 7) ) {
      fputs( reg->symblnam, o_file );
      putc( '\0', o_file );
      fwrite( &reg->s_ofst, 2, 1, o_file );
      var = l2fa8( reg );
      fwrite( &var, 2, 1, o_file );
      l2fd9( reg->wrd );
   }
}
   
